mod compiler_types;

use std::env;
use std::fs;

use lrlex::lrlex_mod;
use lrpar::lrpar_mod;

lrlex_mod!("calc.l");
lrpar_mod!("calc.y");

fn main() {
    let lexerdef = calc_l::lexerdef();
    let args: Vec<String> = env::args().collect();
    let code = fs::read_to_string(&args[1]).unwrap();
    let lexer = lexerdef.lexer(&code);
    let (res, errs) = calc_y::parse(&lexer);
    for e in errs {
        println!("{}", e.pp(&lexer, &calc_y::token_epp));
    }
    match res {
        Some(r) => println!("Result: {:#?}", r),
        _ => eprintln!("Unable to evaluate expression.")
    }
}
